#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityTouchingFishBaseInfo.h"
std::auto_ptr<M_ActivityTouchingFishBaseInfo> M_ActivityTouchingFishBaseInfo::msSingleton(nullptr);

int M_ActivityTouchingFishBaseInfo::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTouchingFishBaseInfoData* M_ActivityTouchingFishBaseInfo::GetData(std::string Key)
{
	auto it = mMapData.find(Key);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<std::string, M_ActivityTouchingFishBaseInfoData>& M_ActivityTouchingFishBaseInfo::GetMapData()
{
	return mMapData;
}

void M_ActivityTouchingFishBaseInfo::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityTouchingFishBaseInfo.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTouchingFishBaseInfoData data;
		data.mKey = element->Attribute("Key");
		data.mValue = element->IntAttribute("Value");
		data.mStringValue = element->Attribute("StringValue");
		if (mMapData.find(data.mKey) != mMapData.end())std::cout <<"data refind:" << data.mKey << std::endl;
		CCASSERT(mMapData.find(data.mKey) == mMapData.end(), "data.mKey is exists");
		mMapData.insert(std::make_pair(data.mKey, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityTouchingFishBaseInfo Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityTouchingFishBaseInfo::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityTouchingFishBaseInfo");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityTouchingFishBaseInfo");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityTouchingFishBaseInfoData data;
		LuaCfgHelper::readString(L, "Key", data.mKey);
		LuaCfgHelper::readInt(L, "Value", data.mValue);
		LuaCfgHelper::readString(L, "StringValue", data.mStringValue);
		if (mMapData.find(data.mKey) != mMapData.end())std::cout <<"data refind:" << data.mKey << std::endl;
		CCASSERT(mMapData.find(data.mKey) == mMapData.end(), "data.mKey is exists");
		mMapData.insert(std::make_pair(data.mKey, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityTouchingFishBaseInfo Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityTouchingFishBaseInfo::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityTouchingFishBaseInfo* M_ActivityTouchingFishBaseInfo::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTouchingFishBaseInfo());
	}
	return msSingleton.get();
}

void M_ActivityTouchingFishBaseInfo::Release()
{
	msSingleton.reset(nullptr);
}
